package cz.cuni.mff.d3s.stdynpor.examples.fields;


public class FLD03
{
	static class A
	{
		protected int num;

		public int getNum() 
		{ 
			return num; 
		}

		public void setNum(int n) 
		{ 
			this.num = n; 
		}
	}

	static class B extends A
	{
	}

	public static void main(String[] args) 
	{
		B b = new B();
		
		Thread t1 = new ReaderThread(b);
		Thread t2 = new WriterThread(b);
		
		t1.start();
		t2.start();
		
		try 
		{
			t1.join();
			t2.join();
		} 
		catch (InterruptedException e) 
		{
			e.printStackTrace();
		}
	}

	static class ReaderThread extends Thread 
	{
		private B b;
		
		public ReaderThread(B b) 
		{
			this.b = b;
		}
		
		public void run() 
		{
			System.out.println("b.num = " + b.getNum());
		}
	}

	static class WriterThread extends Thread 
	{
		private B b;
		
		public WriterThread(B b) 
		{
			this.b = b;
		}
		
		public void run() 
		{
			b.setNum(10);
		}
	}
}

