package cz.cuni.mff.d3s.stdynpor.examples.hbfield;


public class HBF28
{
	public static int count = 0;
	public static final int MAX = 2;

	public static Object full;
	public static Object empty;


	public static void main(String[] args) {
		HBF28.full = new Object();
		HBF28.empty = new Object();

		Thread t1 = new ProducerThread();
		Thread t2 = new ConsumerThread();

		t1.start();
		t2.start();
        
		try {
			t1.join();
			t2.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}


	static class ProducerThread extends Thread
	{
		public ProducerThread() { }
		
		public void run() {
			while (true) {
				while (HBF28.count == HBF28.MAX) {
					synchronized (full) {
						try { full.wait(); } catch (InterruptedException e) {}
					}
				}
				HBF28.count++;
				synchronized (empty) {
					empty.notifyAll();
				}
			}
		}
	}


	static class ConsumerThread extends Thread
	{
		public ConsumerThread() { }
		
		public void run() {
			while (true) {
				while (HBF28.count == 0) {
					synchronized (empty) {
						try { empty.wait(); } catch (InterruptedException e) {}
					}
				}
				HBF28.count--;
				synchronized (full) {
					full.notifyAll();
				}
			}
		}
	}

}


