package cz.cuni.mff.d3s.stdynpor.examples.trheur;

public class TRH04
{
	public static void main(String[] args)
	{
		int[] p1 = new int[4];
		int[] p2 = new int[4];
		int[] p3 = new int[4];
		
		Thread t1 = new PipeThread(1,p1,p2);
		Thread t2 = new PipeThread(2,p2,p3);
		Thread t3 = new PipeThread(3,p1,p3);

		t1.start();
		t2.start();
		t3.start();
		
		try 
		{
			t1.join();
			t2.join();
			t3.join();
		} 
		catch (InterruptedException e) 
		{
			e.printStackTrace();
		}
	}

	static class PipeThread extends Thread 
	{
		private final int[] pIn;
		private final int[] pOut;
		private int id;
		
		public PipeThread(int id, int[] pIn, int[] pOut)
		{
			this.id = id;
			this.pIn = pIn;
			this.pOut = pOut;
		}
		
		public void run() 
		{
			int v;
			
			v = pIn[0];
			System.out.println("v = " + v);
			pOut[0] = v;

			v = pIn[id];
			System.out.println("v = " + v);
			pOut[id] = v + 1;
		}
	}
}

