package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// threads access different elements of the shared array
// constant indexes

public class ARR01
{
    public static void main(String[] args) {
		int[] buf = new int[]{1,2,3,4};

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[] buffer;

	    public WriterThread(int[] buf) {
    	    this.buffer = buf;
    	}

    	public void run() {
			buffer[1] = 5;
    	}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[] buffer;

    	public ReaderThread(int[] buf) {
        	this.buffer = buf;
	    }

    	public void run() {
	        System.out.println("buffer[0] = " + buffer[0]);
    	}
	}
}

