package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// threads accessing same elements of the shared array
// indexes defined as variable expressions (object field)

public class ARR05
{
    public static void main(String[] args) {
		int[] buf = new int[]{1,2,3,4};

        Thread t1 = new ReaderThread(buf, 1);
        Thread t2 = new WriterThread(buf, 2);

        t1.start();
        t2.start();
        
        try {
            t1.join();
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[] buffer;
		private int id;

	    public WriterThread(int[] buf, int id) {
    	    this.buffer = buf;
			this.id = id;
    	}

    	public void run() {
			buffer[id] = 5;
    	}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[] buffer;
		private int id;

    	public ReaderThread(int[] buf, int id) {
        	this.buffer = buf;
			this.id = id;
	    }

    	public void run() {
	        System.out.println("buffer[id+1] = " + buffer[id+1]);
    	}
	}
}

