package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// threads accessing same elements of the shared array where elements have a reference type
// constant indexes

public class ARR08
{
    public static void main(String[] args) {
		Data[] buf = new Data[4];
		for (int i = 0; i < buf.length; i++) buf[i] = new Data();

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private Data[] buffer;

	    public WriterThread(Data[] buf) {
    	    this.buffer = buf;
    	}

    	public void run() {
			buffer[1] = new Data();
    	}
	}

	static class ReaderThread extends Thread 
	{ 
    	private Data[] buffer;

    	public ReaderThread(Data[] buf) {
        	this.buffer = buf;
	    }

    	public void run() {
	        System.out.println("buffer[1] = " + buffer[1]);
    	}
	}
	
	static class Data
	{
		public int id;	
	}
}

