package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// array index derived from an object field (using arithmetic expression)

public class ARR12
{
    public static void main(String[] args) {
		int[] buf = new int[]{1,2,3,4};

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[] buffer;
    	private int wpos;

	    public WriterThread(int[] buf) {
    	    this.buffer = buf;
    	    this.wpos = 0;
    	}

    	public void run() {
    		buffer[wpos] = 5;
			wpos = wpos + 1;
    		buffer[1] = 8;
    		wpos += 1;
    		buffer[wpos] = 10;
			wpos = wpos + 1;
		}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[] buffer;
    	private int rpos;

    	public ReaderThread(int[] buf) {
        	this.buffer = buf;
        	this.rpos = 0;
	    }

    	public void run() {
	        System.out.println("buffer[0] = " + buffer[0]);
	        rpos = rpos + 2;
	        System.out.println("buffer[2] = " + buffer[rpos]); 
		}
	}
}

