package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// MAIN: start T2 ; join T2 ; start T1 
// T1: read X
// T2: write X

// Note: T2 finishes before the start of T1 
// Note: we have dependency between t2.join() and the start of t1 (and all events inside t1)

public class HBF07 
{
    public static int x = 0;

    public static void main(String[] args) {
        Thread t1 = new ReaderThread();
        Thread t2 = new InitThread();

        t2.start();

        try {
            t2.join();
        } catch (InterruptedException e) {}

        t1.start();

        try {
            t1.join(); 
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class ReaderThread extends Thread 
	{
	    public ReaderThread() {
	    }

    	public void run() {
        	System.out.println("x=" + HBF07.x);
    	}
	}

	static class InitThread extends Thread 
	{
    	public void run() {
        	HBF07.x = 2;
	    }
	}
}

