package cz.cuni.mff.d3s.stdynpor.examples.trheur;

public class TRH03
{
	public static void main(String[] args)
	{
		Data d1 = new Data();
		Data d2 = new Data();
		
		Thread t1 = new SeqThread(1,d1,d2,d1);
		Thread t2 = new SeqThread(2,d2,d1,d1);
		Thread t3 = new SeqThread(3,d1,d1,d2);

		t1.start();
		t2.start();
		t3.start();
		
		try 
		{
			t1.join();
			t2.join();
			t3.join();
		} 
		catch (InterruptedException e) 
		{
			e.printStackTrace();
		}
	}

	static class SeqThread extends Thread 
	{
		private int id;

		private final Data d1;
		private final Data d2;
		private final Data d3;

		public SeqThread(int id, Data d1, Data d2, Data d3)
		{
			this.id = id;
			this.d1 = d1;
			this.d2 = d2;
			this.d3 = d3;
		}
		
		public void run()
		{
			System.out.println("d1.val = " + d1.val);
			System.out.println("d1.val = " + d1.val);

			d2.val = 2*id;
			d2.val = 2*id+1;

			System.out.println("d3.val = " + d3.val);
			System.out.println("d3.val = " + d3.val);
		}
	}

	static class Data
	{	
		public int val = 0;
	}
}

